diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/stats/CMakeLists.txt ns-3.41/src/stats/CMakeLists.txt
--- ns-3.40/src/stats/CMakeLists.txt	2023-09-27 13:30:37.878839700 -0700
+++ ns-3.41/src/stats/CMakeLists.txt	2024-02-09 14:44:08.501794300 -0800
@@ -1,6 +1,6 @@
 set(sqlite_sources)
 set(sqlite_headers)
-set(private_sqlite_header)
+set(private_sqlite_headers)
 set(sqlite_libraries)
 if(${ENABLE_SQLITE})
   set(sqlite_sources
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/tap-bridge/CMakeLists.txt ns-3.41/src/tap-bridge/CMakeLists.txt
--- ns-3.40/src/tap-bridge/CMakeLists.txt	2023-09-27 13:30:37.882839700 -0700
+++ ns-3.41/src/tap-bridge/CMakeLists.txt	2024-02-09 14:44:08.505794300 -0800
@@ -28,10 +28,7 @@
     helper/tap-bridge-helper.h
     model/tap-bridge.h
     model/tap-encode-decode.h
-  LIBRARIES_TO_LINK
-    ${libcore}
-    ${libinternet}
-    ${libnetwork}
+  LIBRARIES_TO_LINK ${libinternet}
 )
 
 add_definitions(
@@ -41,6 +38,7 @@
   EXECNAME tap-creator
   SOURCE_FILES model/tap-creator.cc
                model/tap-encode-decode.cc
+  LIBRARIES_TO_LINK ${libnetwork}
   EXECUTABLE_DIRECTORY_PATH ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/src/tap-bridge/
   INSTALL_DIRECTORY_PATH ${CMAKE_INSTALL_LIBEXECDIR}/ns3
   STANDALONE
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/tap-bridge/examples/tap-csma-virtual-machine.py ns-3.41/src/tap-bridge/examples/tap-csma-virtual-machine.py
--- ns-3.40/src/tap-bridge/examples/tap-csma-virtual-machine.py	2023-09-27 13:30:37.882839700 -0700
+++ ns-3.41/src/tap-bridge/examples/tap-csma-virtual-machine.py	2024-02-09 14:44:08.505794300 -0800
@@ -18,10 +18,17 @@
 
 import sys
 
-from ns import ns
+try:
+    from ns import ns
+except ModuleNotFoundError:
+    raise SystemExit(
+        "Error: ns3 Python module not found;"
+        " Python bindings may not be enabled"
+        " or your PYTHONPATH might not be properly configured"
+    )
 
-def main(argv):
 
+def main(argv):
     ns.core.CommandLine().Parse(argv)
 
     #
@@ -29,7 +36,9 @@
     # interact in real-time and therefore we have to use the real-time simulator
     # and take the time to calculate checksums.
     #
-    ns.core.GlobalValue.Bind("SimulatorImplementationType", ns.core.StringValue("ns3::RealtimeSimulatorImpl"))
+    ns.core.GlobalValue.Bind(
+        "SimulatorImplementationType", ns.core.StringValue("ns3::RealtimeSimulatorImpl")
+    )
     ns.core.GlobalValue.Bind("ChecksumEnabled", ns.core.BooleanValue(True))
 
     #
@@ -38,7 +47,7 @@
     # the right side.
     #
     nodes = ns.network.NodeContainer()
-    nodes.Create (2)
+    nodes.Create(2)
 
     #
     # Use a CsmaHelper to get a CSMA channel created, and the needed net
@@ -57,24 +66,25 @@
     # for this configuration.
     #
     tapBridge = ns.tap_bridge.TapBridgeHelper()
-    tapBridge.SetAttribute ("Mode", ns.core.StringValue ("UseLocal"))
-    tapBridge.SetAttribute ("DeviceName", ns.core.StringValue ("tap-left"))
-    tapBridge.Install (nodes.Get (0), devices.Get (0))
+    tapBridge.SetAttribute("Mode", ns.core.StringValue("UseLocal"))
+    tapBridge.SetAttribute("DeviceName", ns.core.StringValue("tap-left"))
+    tapBridge.Install(nodes.Get(0), devices.Get(0))
 
     #
     # Connect the right side tap to the right side wifi device on the right-side
     # ghost node.
     #
-    tapBridge.SetAttribute ("DeviceName", ns.core.StringValue ("tap-right"))
-    tapBridge.Install (nodes.Get (1), devices.Get (1))
+    tapBridge.SetAttribute("DeviceName", ns.core.StringValue("tap-right"))
+    tapBridge.Install(nodes.Get(1), devices.Get(1))
 
     #
     # Run the simulation for ten minutes to give the user time to play around
     #
-    ns.core.Simulator.Stop (ns.core.Seconds (600))
-    ns.core.Simulator.Run()#signal_check_frequency = -1
+    ns.core.Simulator.Stop(ns.core.Seconds(600))
+    ns.core.Simulator.Run()  # signal_check_frequency = -1
     ns.core.Simulator.Destroy()
     return 0
 
-if __name__ == '__main__':
+
+if __name__ == "__main__":
     sys.exit(main(sys.argv))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/tap-bridge/examples/tap-wifi-dumbbell.cc ns-3.41/src/tap-bridge/examples/tap-wifi-dumbbell.cc
--- ns-3.40/src/tap-bridge/examples/tap-wifi-dumbbell.cc	2023-09-27 13:30:37.882839700 -0700
+++ ns-3.41/src/tap-bridge/examples/tap-wifi-dumbbell.cc	2024-02-09 14:44:08.505794300 -0800
@@ -144,7 +144,7 @@
     Ssid ssid = Ssid("left");
     WifiHelper wifi;
     WifiMacHelper wifiMac;
-    wifi.SetRemoteStationManager("ns3::ArfWifiManager");
+    wifi.SetStandard(WIFI_STANDARD_80211a);
 
     wifiMac.SetType("ns3::ApWifiMac", "Ssid", SsidValue(ssid));
     NetDeviceContainer devicesLeft = wifi.Install(wifiPhy, wifiMac, nodesLeft.Get(0));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/tap-bridge/examples/tap-wifi-virtual-machine.py ns-3.41/src/tap-bridge/examples/tap-wifi-virtual-machine.py
--- ns-3.40/src/tap-bridge/examples/tap-wifi-virtual-machine.py	2023-09-27 13:30:37.882839700 -0700
+++ ns-3.41/src/tap-bridge/examples/tap-wifi-virtual-machine.py	2024-02-09 14:44:08.525794500 -0800
@@ -17,10 +17,18 @@
 #
 
 import sys
-from ns import ns
 
-def main(argv):
+try:
+    from ns import ns
+except ModuleNotFoundError:
+    raise SystemExit(
+        "Error: ns3 Python module not found;"
+        " Python bindings may not be enabled"
+        " or your PYTHONPATH might not be properly configured"
+    )
+
 
+def main(argv):
     ns.core.CommandLine().Parse(argv)
 
     #
@@ -28,7 +36,9 @@
     # interact in real-time and therefore we have to use the real-time simulator
     # and take the time to calculate checksums.
     #
-    ns.core.GlobalValue.Bind("SimulatorImplementationType", ns.core.StringValue("ns3::RealtimeSimulatorImpl"))
+    ns.core.GlobalValue.Bind(
+        "SimulatorImplementationType", ns.core.StringValue("ns3::RealtimeSimulatorImpl")
+    )
     ns.core.GlobalValue.Bind("ChecksumEnabled", ns.core.BooleanValue(True))
 
     #
@@ -37,20 +47,22 @@
     # the right side.
     #
     nodes = ns.network.NodeContainer()
-    nodes.Create (2);
+    nodes.Create(2)
 
     #
     # We're going to use 802.11 A so set up a wifi helper to reflect that.
     #
     wifi = ns.wifi.WifiHelper()
-    wifi.SetStandard (ns.wifi.WIFI_STANDARD_80211a);
-    wifi.SetRemoteStationManager ("ns3::ConstantRateWifiManager", "DataMode", ns.core.StringValue ("OfdmRate54Mbps"));
+    wifi.SetStandard(ns.wifi.WIFI_STANDARD_80211a)
+    wifi.SetRemoteStationManager(
+        "ns3::ConstantRateWifiManager", "DataMode", ns.core.StringValue("OfdmRate54Mbps")
+    )
 
     #
     # No reason for pesky access points, so we'll use an ad-hoc network.
     #
     wifiMac = ns.wifi.WifiMacHelper()
-    wifiMac.SetType ("ns3::AdhocWifiMac");
+    wifiMac.SetType("ns3::AdhocWifiMac")
 
     #
     # Configure the physical layer.
@@ -73,7 +85,7 @@
     positionAlloc.Add(ns.core.Vector(0.0, 0.0, 0.0))
     positionAlloc.Add(ns.core.Vector(5.0, 0.0, 0.0))
     mobility.SetPositionAllocator(positionAlloc)
-    mobility.SetMobilityModel ("ns3::ConstantPositionMobilityModel")
+    mobility.SetMobilityModel("ns3::ConstantPositionMobilityModel")
     mobility.Install(nodes)
 
     #
@@ -85,25 +97,25 @@
     # for this configuration.
     #
     tapBridge = ns.tap_bridge.TapBridgeHelper()
-    tapBridge.SetAttribute ("Mode", ns.core.StringValue ("UseLocal"));
-    tapBridge.SetAttribute ("DeviceName", ns.core.StringValue ("tap-left"));
-    tapBridge.Install (nodes.Get (0), devices.Get (0));
+    tapBridge.SetAttribute("Mode", ns.core.StringValue("UseLocal"))
+    tapBridge.SetAttribute("DeviceName", ns.core.StringValue("tap-left"))
+    tapBridge.Install(nodes.Get(0), devices.Get(0))
 
     #
     # Connect the right side tap to the right side wifi device on the right-side
     # ghost node.
     #
-    tapBridge.SetAttribute ("DeviceName", ns.core.StringValue ("tap-right"));
-    tapBridge.Install (nodes.Get (1), devices.Get (1));
+    tapBridge.SetAttribute("DeviceName", ns.core.StringValue("tap-right"))
+    tapBridge.Install(nodes.Get(1), devices.Get(1))
 
     #
     # Run the simulation for ten minutes to give the user time to play around
     #
-    ns.core.Simulator.Stop (ns.core.Seconds (600));
-    ns.core.Simulator.Run()#signal_check_frequency = -1
+    ns.core.Simulator.Stop(ns.core.Seconds(600))
+    ns.core.Simulator.Run()  # signal_check_frequency = -1
     ns.core.Simulator.Destroy()
     return 0
 
-if __name__ == '__main__':
-    sys.exit(main(sys.argv))
 
+if __name__ == "__main__":
+    sys.exit(main(sys.argv))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/tap-bridge/model/tap-bridge.cc ns-3.41/src/tap-bridge/model/tap-bridge.cc
--- ns-3.40/src/tap-bridge/model/tap-bridge.cc	2023-09-27 13:30:37.882839700 -0700
+++ ns-3.41/src/tap-bridge/model/tap-bridge.cc	2024-02-09 14:44:08.525794500 -0800
@@ -135,7 +135,7 @@
             .AddAttribute("Mode",
                           "The operating and configuration mode to use.",
                           EnumValue(USE_LOCAL),
-                          MakeEnumAccessor(&TapBridge::SetMode),
+                          MakeEnumAccessor<Mode>(&TapBridge::SetMode),
                           MakeEnumChecker(CONFIGURE_LOCAL,
                                           "ConfigureLocal",
                                           USE_LOCAL,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/tap-bridge/model/tap-bridge.h ns-3.41/src/tap-bridge/model/tap-bridge.h
--- ns-3.40/src/tap-bridge/model/tap-bridge.h	2023-09-27 13:30:37.882839700 -0700
+++ ns-3.41/src/tap-bridge/model/tap-bridge.h	2024-02-09 14:44:08.525794500 -0800
@@ -459,7 +459,7 @@
      * whether or not ns-3 is connected to the underlying TAP device
      * with a file descriptor.
      */
-    bool m_linkUp;
+    bool m_linkUp{false};
 
     /**
      * Flag indicating whether or not the link is up.  In this case,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/tap-bridge/model/tap-creator.cc ns-3.41/src/tap-bridge/model/tap-creator.cc
--- ns-3.40/src/tap-bridge/model/tap-creator.cc	2023-09-27 13:30:37.882839700 -0700
+++ ns-3.41/src/tap-bridge/model/tap-creator.cc	2024-02-09 14:44:08.525794500 -0800
@@ -17,6 +17,8 @@
 
 #include "tap-encode-decode.h"
 
+#include "ns3/mac48-address.h"
+
 #include <cerrno>
 #include <cstdlib>
 #include <cstring> // for strerror
@@ -61,89 +63,6 @@
         ABORT(msg, printErrno);                                                                    \
     }
 
-//
-// Lots of the following helper code taken from corresponding functions in src/node.
-//
-#define ASCII_DOT (0x2e)
-#define ASCII_ZERO (0x30)
-#define ASCII_a (0x41)
-#define ASCII_z (0x5a)
-#define ASCII_A (0x61)
-#define ASCII_Z (0x7a)
-#define ASCII_COLON (0x3a)
-
-static char
-AsciiToLowCase(char c)
-{
-    if (c >= ASCII_a && c <= ASCII_z)
-    {
-        return c;
-    }
-    else if (c >= ASCII_A && c <= ASCII_Z)
-    {
-        return c + (ASCII_a - ASCII_A);
-    }
-    else
-    {
-        return c;
-    }
-}
-
-static uint32_t
-AsciiToIpv4(const char* address)
-{
-    uint32_t host = 0;
-    while (true)
-    {
-        uint8_t byte = 0;
-        while (*address != ASCII_DOT && *address != 0)
-        {
-            byte *= 10;
-            byte += *address - ASCII_ZERO;
-            address++;
-        }
-        host <<= 8;
-        host |= byte;
-        if (*address == 0)
-        {
-            break;
-        }
-        address++;
-    }
-    return host;
-}
-
-static void
-AsciiToMac48(const char* str, uint8_t addr[6])
-{
-    int i = 0;
-    while (*str != 0 && i < 6)
-    {
-        uint8_t byte = 0;
-        while (*str != ASCII_COLON && *str != 0)
-        {
-            byte <<= 4;
-            char low = AsciiToLowCase(*str);
-            if (low >= ASCII_a)
-            {
-                byte |= low - ASCII_a + 10;
-            }
-            else
-            {
-                byte |= low - ASCII_ZERO;
-            }
-            str++;
-        }
-        addr[i] = byte;
-        i++;
-        if (*str == 0)
-        {
-            break;
-        }
-        str++;
-    }
-}
-
 static sockaddr
 CreateInetAddress(uint32_t networkOrder)
 {
@@ -326,7 +245,7 @@
     // Set the hardware (MAC) address of the new device
     //
     ifr.ifr_hwaddr.sa_family = 1; // this is ARPHRD_ETHER from if_arp.h
-    AsciiToMac48(mac, (uint8_t*)ifr.ifr_hwaddr.sa_data);
+    ns3::Mac48Address(mac).CopyTo((uint8_t*)ifr.ifr_hwaddr.sa_data);
     status = ioctl(tap, SIOCSIFHWADDR, &ifr);
     ABORT_IF(status == -1, "Could not set MAC address", true);
     LOG("Set device MAC address to " << mac);
@@ -346,7 +265,7 @@
     //
     // Set the IP address of the new interface/device.
     //
-    ifr.ifr_addr = CreateInetAddress(AsciiToIpv4(ip));
+    ifr.ifr_addr = CreateInetAddress(ns3::Ipv4Address(ip).Get());
     status = ioctl(fd, SIOCSIFADDR, &ifr);
     ABORT_IF(status == -1, "Could not set IP address", true);
     LOG("Set device IP address to " << ip);
@@ -354,7 +273,7 @@
     //
     // Set the net mask of the new interface/device
     //
-    ifr.ifr_netmask = CreateInetAddress(AsciiToIpv4(netmask));
+    ifr.ifr_netmask = CreateInetAddress(ns3::Ipv4Mask(netmask).Get());
     status = ioctl(fd, SIOCSIFNETMASK, &ifr);
     ABORT_IF(status == -1, "Could not set net mask", true);
     LOG("Set device Net Mask to " << netmask);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/test/CMakeLists.txt ns-3.41/src/test/CMakeLists.txt
--- ns-3.40/src/test/CMakeLists.txt	2023-09-27 13:30:37.882839700 -0700
+++ ns-3.41/src/test/CMakeLists.txt	2024-02-09 14:44:08.525794500 -0800
@@ -22,6 +22,7 @@
   )
     # cmake-format: off
     set(applications_sources
+        ns3tcp/ns3tcp-cubic-test-suite.cc
         ns3tcp/ns3tcp-loss-test-suite.cc
         ns3tcp/ns3tcp-no-delay-test-suite.cc
         ns3tcp/ns3tcp-socket-test-suite.cc
